/*
* nuage3D.h
* 
* Copyright (C) 2016, Tristan Dagobert, CMLA, École Normale Supérieure de Cachan.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or 
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#if !(defined NUAGE3D_H)
#define NUAGE3D_H
/*===========================================================================*/
#define NORMALIZATION 0
#define INV_NORMALIZATION 1
#define NON_NORMALIZATION 2
/*===========================================================================*/
struct point_s
{
  long double x;
  long double y;
  long double z;
  long double w;
};
typedef struct point_s point_t;

struct contributions_s
{
  short int nb_contribs;	/* number of contributions */
  short int xpos;		/* x coordinate into the image */
  short int ypos;		/* x coordinate into the image */
  float *x;			/* array of x components of contributions */
  float *y;			/* array of y components of contributions */
  float *c;			/* array of z components of contributions */
};
typedef struct contributions_s contributions_t;
/*===========================================================================*/
void
reading_image_dimensions (char *filename_contributions, int xmax[1],
			  int ymax[1]);
contributions_t **allocating_contributions (int nlig, int ncol);

contributions_t **loading_contributions (char *filename_contributions,
					 int xmin, int ymin, int xmax,
					 int ymax, int *ncbs);
void freeing_contributions (contributions_t ** MC, int nlig, int ncol);
void
loading_matrices (char *filename,
		  long double mat_image_to_camera[4][4],
		  long double mat_camera_to_absolute[4][4]);
void
converting_coordinates (point_t ante_pt, point_t * neo_pt,
			long double M[4][4], int normer);
void writing_geometric_points (char *filename, contributions_t ** MC,
			       char *filename_matrices, int nlig, int ncol);
void computing_geometric_points (char *filename_contributions,
				 char *filename_matrices, char *outfile);

/*===========================================================================*/

#endif
